Index: sandbox/workflow/branches/1015/inc/local/classes/class.wf_natural.php
===================================================================
--- sandbox/workflow/branches/1015/inc/local/classes/class.wf_natural.php	(revision 795)
+++ sandbox/workflow/branches/1015/inc/local/classes/class.wf_natural.php	(revision 3061)
@@ -1,130 +1,114 @@
 <?php
-	require_once(PHPGW_SERVER_ROOT.SEP.'workflow'.SEP.'inc'.SEP.'natural'.SEP.'class.natural.php');
+/**************************************************************************\
+* eGroupWare                                                               *
+* http://www.egroupware.org                                                *
+* --------------------------------------------                             *
+*  This program is free software; you can redistribute it and/or modify it *
+*  under the terms of the GNU General Public License as published by the   *
+*  Free Software Foundation; either version 2 of the License, or (at your  *
+*  option) any later version.                                              *
+\**************************************************************************/
+
+require_once(PHPGW_SERVER_ROOT.SEP.'workflow'.SEP.'inc'.SEP.'natural'.SEP.'class.natural.php');
+
+/**
+ * Mainframe connection to workflow
+ *
+ * TODO - This class should be removed from here. Its based on a not
+ * public protocol, thus cannot be used for everybody.
+ *
+ * @package Workflow
+ * @subpackage local
+ * @license http://www.gnu.org/copyleft/gpl.html GPL
+ * @author Everton Flávio Rufino Seára
+ */
+class wf_natural extends Natural
+{
 
 	/**
-	* Mainframe connection to workflow
-	* @author Everton Flávio Rufino Seára
-	* @package Workflow
-	* @subpackage local
-	* @license http://www.gnu.org/copyleft/gpl.html GPL
-	**/
+	 * @var object Log Object
+	 * @access private
+	 */
+	private $logger = null;
 
-	class wf_natural extends Natural
+	function __construct()
 	{
+		parent::Natural();
 
-		function __construct()
-		{
-			parent::Natural();
+		$natconf = array(
+					'mainframe_ip'			=> '',
+					'mainframe_port'		=> '',
+					'mainframe_key'			=> '',
+					'mainframe_password'	=> '',
+					'mainframe_environment'	=> ''
+		);
 
-			$natconf = array(
-						'mainframe_ip'			=> '',
-						'mainframe_port'		=> '',
-						'mainframe_key'			=> '',
-						'mainframe_password'	=> '',
-						'mainframe_environment'	=> ''
-			);
+		$nat_conf_values = &Factory::getInstance('workflow_wfruntime')->getConfigValues($natconf);
 
-			$nat_conf_values = $GLOBALS['workflow']['wf_runtime']->getConfigValues($natconf);
+		$this->setIPAddress($nat_conf_values['mainframe_ip']);
+		$this->setServerPort($nat_conf_values['mainframe_port']);
+		$this->setKey($nat_conf_values['mainframe_key']);
+		$this->setPassword($nat_conf_values['mainframe_password']);
+		$this->setApplication($nat_conf_values['mainframe_environment']);
 
-			$this->setIPAddress($nat_conf_values['mainframe_ip']);
-			$this->setServerPort($nat_conf_values['mainframe_port']);
-			$this->setKey($nat_conf_values['mainframe_key']);
-			$this->setPassword($nat_conf_values['mainframe_password']);
-			$this->setApplication($nat_conf_values['mainframe_environment']);
+		$this->logger = &Factory::getInstance('Logger', array('file'));
+	}
+
+	/**
+	 * This method MUST be called before using execute method
+	 * It specifies the natural sub-program to be accessed.
+	 *
+	 * @param Object $obj Object that specifies natural sub-program properties
+	 * @return void
+	 */
+	public function configure($obj)
+	{
+		$this->obj = $obj;
+
+		$this->initialize($obj->name);
+
+		if ($obj->server != NULL){
+			$this->setIPAddress($obj->server);
 		}
-
-		/**
-		 * Method to configure the access to mainframe
-		 * This method MUST be called before using execute method, else 'false' will be returned
-		 *
-		 * Only the first and second param are mandatory.
-		 *
-		 * @param String $subProgram - Name of sub-program
-		 * @param String $inputParameter - Input parameters to sub-program
-		 *
-		 * @param String $ip - IP Address of Mainfram
-		 * @param int $port - ServerPort to access the mainframe
-		 * @param String $key - Access key (user)
-		 * @param String $password - Key (user) password
-		 * @param char $environment - Application environment access 'D' (development) or 'P' (production)
-
-		 */
-
-		public function configure($obj)
-		{
-			$this->obj = $obj;
-
-			$this->initialize($obj->name);
-
-			if ($obj->server != NULL){
-				$this->setIPAddress($obj->server);
-			}
-			if ($obj->port != NULL){
-				$this->setServerPort($obj->port);
-			}
-			if ($obj->key != NULL){
-				$this->setKey($obj->key);
-			}
-			if ($obj->password != NULL){
-				$this->setPassword($obj->password);
-			}
-			if ($obj->environment != NULL){
-				$this->setApplication($obj->environment);
-			}
-			if ($obj->logon != NULL){
-				$this->setLogon($obj->logon);
-			}
-			if ($obj->system != NULL){
-				$this->setSystem($obj->system);
-			}
-			if ($obj->rc != NULL){
-				$this->setRC($obj->rc);
-			}
+		if ($obj->port != NULL){
+			$this->setServerPort($obj->port);
 		}
-
-		/*
-
-		public function configure($subProgram, $inputParameter, $ip = NULL, $port = NULL,
-										$key = NULL, $password = NULL, $environment = NULL, $logon = NULL, $system = NULL, $rc = NULL)
-		{
-			$this->initialize($subProgram, $inputParameter);
-
-			if ($ip != NULL){
-				$this->setIPAddress($ip);
-			}
-			if ($port != NULL){
-				$this->setServerPort($port);
-			}
-			if ($key != NULL){
-				$this->setKey($key);
-			}
-			if ($password != NULL){
-				$this->setPassword($password);
-			}
-			if ($environment != NULL){
-				$this->setApplication($environment);
-			}
-			if ($logon != NULL){
-				$this->setLogon($logon);
-			}
-			if ($system != NULL){
-				$this->setSystem($system);
-			}
-			if ($rc != NULL){
-				$this->setRC($rc);
-			}
-
+		if ($obj->key != NULL){
+			$this->setKey($obj->key);
 		}
-
-		 */
-
-		/**
-		 * Access and retrieve data from mainframe
-		 * @return bool
-		 */
-		public function execute($inputParams = "")
-		{
-			return parent::execute($inputParams);
+		if ($obj->password != NULL){
+			$this->setPassword($obj->password);
+		}
+		if ($obj->environment != NULL){
+			$this->setApplication($obj->environment);
+		}
+		if ($obj->logon != NULL){
+			$this->setLogon($obj->logon);
+		}
+		if ($obj->system != NULL){
+			$this->setSystem($obj->system);
+		}
+		if ($obj->rc != NULL){
+			$this->setRC($obj->rc);
 		}
 	}
+
+	/**
+	 * Method for accessing and retrieving data from mainframe
+	 * @return bool
+	 */
+	public function execute($inputParams = "")
+	{
+		// execute action and log wasted time
+		$totalTime = microtime(true);
+		$result = parent::execute($inputParams);
+		$totalTime = microtime(time) - $totalTime;
+		$log = sprintf("WF_NATURAL [subprogram=%s] [time=%ss]",
+					$this->obj->name,
+					number_format($totalTime,3)
+					);
+		$this->logger->debug($log);
+		return $result;
+	}
+}
 ?>
Index: sandbox/workflow/branches/1015/inc/local/classes/class.wf_orgchart.php
===================================================================
--- sandbox/workflow/branches/1015/inc/local/classes/class.wf_orgchart.php	(revision 2588)
+++ sandbox/workflow/branches/1015/inc/local/classes/class.wf_orgchart.php	(revision 3061)
@@ -480,4 +480,38 @@
 		return $output;
 	}
+	
+	/**
+	 * Return all areas that the employee is a supervisor.
+	 * 
+	 * Search in the organization for all areas that the employee is a supervisor.
+	 * @param int $employeeID The ID of employee
+	 * @return array Array containing all the areas that the employeee is a supervisor.
+	 * @access public
+	 */
+	function getSupervisorAreas($employeeID) {
+
+		if (!$employeeID) {
+			return false;
+		}
+
+		$query = "SELECT 
+						a.area_id
+					FROM 
+						area a 
+						LEFT OUTER JOIN substituicao s ON ((a.area_id = s.area_id) 
+						AND (CURRENT_DATE BETWEEN s.data_inicio AND s.data_fim)) 
+					WHERE 
+						a.titular_funcionario_id = ? OR 
+						s.funcionario_id = ?
+					GROUP BY
+						a.area_id";
+		
+		$result = $this->db->query($query, array($employeeID,$employeeID));
+		if (!$result)
+			return false;
+		
+		$output = $result->GetArray(-1);
+		return $output;
+	}
 
 	/**
Index: sandbox/workflow/branches/1015/inc/class.workflow_processmanager.inc.php
===================================================================
--- sandbox/workflow/branches/1015/inc/class.workflow_processmanager.inc.php	(revision 2372)
+++ sandbox/workflow/branches/1015/inc/class.workflow_processmanager.inc.php	(revision 3061)
@@ -226,14 +226,4 @@
 			  fclose($fp);
 			  $out.='      ]]></code>';
-			  if($res['wf_is_interactive']=='y') {
-				$out.='      <template><![CDATA[';
-				$fp=fopen(GALAXIA_PROCESSES.SEP."$wf_procname".SEP."code".SEP."templates".SEP."$name.tpl","r");
-				//while(!feof($fp)) {
-				//	$line=fread($fp,8192);
-					$out.=''; //all templatess will be exported in another section
-				//}
-				fclose($fp);
-				$out.='      ]]></template>';
-			  }
 			  $out.='    </activity>'."\n";    
 			}
Index: sandbox/workflow/branches/1015/inc/class.so_move_instances.inc.php
===================================================================
--- sandbox/workflow/branches/1015/inc/class.so_move_instances.inc.php	(revision 2588)
+++ sandbox/workflow/branches/1015/inc/class.so_move_instances.inc.php	(revision 3061)
@@ -318,23 +318,4 @@
 		}
 
-		/* format the array elements for use in a SELECT SQL statement, e.g. [iid => 12, aid = 27] would produce (12, 27) */
-		$instanceActivityList = array_map(create_function('$e', 'return \'(\' . $e[\'iid\'] . \', \' . $e[\'aid\'] . \')\';'), $instanceActivityList);
-
-		/* update the interinstance relations of the modified rows of the instance_activities table */
-		$resultSet = $this->db->query("SELECT wf_parent_instance_id, wf_parent_activity_id FROM egw_wf_interinstance_relations WHERE ((wf_parent_instance_id, wf_parent_activity_id) IN (" . implode(', ', $instanceActivityList) . "))");
-		$rows = $resultSet->GetArray(-1);
-		if (is_array($rows))
-		{
-			foreach ($rows as $row)
-			{
-				/* update the activity ID */
-				if (!$this->db->query("UPDATE egw_wf_interinstance_relations SET wf_parent_activity_id = ? WHERE (wf_parent_instance_id = ?) AND (wf_parent_activity_id = ?)", array($activitiesConvert[$row['wf_parent_activity_id']], $row['wf_parent_instance_id'], $row['wf_parent_activity_id'])))
-				{
-					$this->db->FailTrans();
-					return array('error' => 'Erro atualizando a tabela de relacionamento inter-instância. Nenhuma modificação foi salva');
-				}
-			}
-		}
-
 		/* in case of success, commit the modifications */
 		$this->db->CompleteTrans();
Index: sandbox/workflow/branches/1015/inc/log/Log/observer.php
===================================================================
--- sandbox/workflow/branches/1015/inc/log/Log/observer.php	(revision 795)
+++ sandbox/workflow/branches/1015/inc/log/Log/observer.php	(revision 3061)
@@ -79,5 +79,5 @@
          */
         if (class_exists($class)) {
-            $object = &new $class($priority, $conf);
+            $object = new $class($priority, $conf);
             return $object;
         }
@@ -103,7 +103,7 @@
             /* Support both new-style and old-style construction. */
             if ($newstyle) {
-                $object = &new $class($priority, $conf);
+                $object = new $class($priority, $conf);
             } else {
-                $object = &new $class($priority);
+                $object = new $class($priority);
             }
             return $object;
Index: sandbox/workflow/branches/1015/inc/log/Log.php
===================================================================
--- sandbox/workflow/branches/1015/inc/log/Log.php	(revision 795)
+++ sandbox/workflow/branches/1015/inc/log/Log.php	(revision 3061)
@@ -167,5 +167,5 @@
         /* If the class exists, return a new instance of it. */
         if (Log::_classExists($class)) {
-            $obj = &new $class($name, $ident, $conf, $level);
+            $obj = new $class($name, $ident, $conf, $level);
             return $obj;
         }
Index: sandbox/workflow/branches/1015/inc/class.basemodel.inc.php
===================================================================
--- sandbox/workflow/branches/1015/inc/class.basemodel.inc.php	(revision 795)
+++ sandbox/workflow/branches/1015/inc/class.basemodel.inc.php	(revision 3061)
@@ -167,9 +167,10 @@
     * @param string $obj Class name
     * @return mixed
-    * @deprecated
+    * @deprecated 2.2.00.000
     * @access public
     */
 	function &getInstance($obj)
-    {
+	{
+		wf_warn_deprecated_method('Factory', 'getInstance');
 		return(wf_create_object(strtolower($obj)));
 	}
Index: sandbox/workflow/branches/1015/inc/engine/src/ProcessMonitor/ProcessMonitor.php
===================================================================
--- sandbox/workflow/branches/1015/inc/engine/src/ProcessMonitor/ProcessMonitor.php	(revision 2372)
+++ sandbox/workflow/branches/1015/inc/engine/src/ProcessMonitor/ProcessMonitor.php	(revision 3061)
@@ -59,7 +59,8 @@
 
   /**
-   * @deprecated
+   * @deprecated 2.2.00.000
    */
   function update_instance_status($iid,$status) {
+	wf_warn_deprecated_method();
     return;
     $query = "update `".GALAXIA_TABLE_PREFIX."instances` set `wf_status`=? where `wf_instance_id`=?";
@@ -69,7 +70,8 @@
   
   /**
-   * @deprecated
+   * @deprecated 2.2.00.000
    */
   function update_instance_activity_status($iid,$activityId,$status) {
+	wf_warn_deprecated_method();
     return;
     $query = "update `".GALAXIA_TABLE_PREFIX."instance_activities` set `wf_status`=? where `wf_instance_id`=? and `wf_activity_id`=?";
